Index: /bdm/stat/emix.cpp
===================================================================
--- /bdm/stat/emix.cpp (revision 254)
+++ /bdm/stat/emix.cpp (revision 270)
@@ -5,7 +5,8 @@
 void emix::set_parameters ( const vec &w0, const Array<epdf*> &Coms0, bool copy ) {
 	w = w0/sum ( w0 );
+	dim = Coms0(0)->dimension();
 	int i;
 	for ( i=0;i<w.length();i++ ) {
-		it_assert_debug ( rv.equal ( Coms0 ( i )->_rv() ),"RVs do not match!" );
+		it_assert_debug ( dim== ( Coms0 ( i )->dimension() ),"Component sizes do not match!" );
 	}
 	if ( copy ) {
@@ -35,7 +36,9 @@
 
 emix* emix::marginal(const RV &rv) const{
+	it_assert_debug(isnamed(), "rvs are not assigned");
+			
 	Array<epdf*> Cn(Coms.length());
 	for(int i=0;i<Coms.length();i++){Cn(i)=Coms(i)->marginal(rv);}
-	emix* tmp = new emix(rv);
+	emix* tmp = new emix();
 	tmp->set_parameters(w,Cn,false);
 	tmp->ownComs();
@@ -44,4 +47,5 @@
 
 mratio* emix::condition(const RV &rv) const{
+	it_assert_debug(isnamed(), "rvs are not assigned");
 	return new mratio(this,rv);
 };
Index: /bdm/stat/libDS.h
===================================================================
--- /bdm/stat/libDS.h (revision 267)
+++ /bdm/stat/libDS.h (revision 270)
@@ -23,5 +23,5 @@
 	* \brief Memory storage of off-line data column-wise
 
-	The data are stored in an internal matrix \c Data . Each column of Data corresponds to one discrete time observation \f$t\f$. Access to this matrix is via indexes \c rowid and \c delays.
+	The data are stored in an internal matrix \c Data . Each column of Data corresponds to one discrete time observation \f$t\f$. Access to this matrix is via indices \c rowid and \c delays.
 
 	The data can be loaded from a file.
@@ -40,7 +40,7 @@
 		void getdata ( vec &dt );
 		void getdata ( vec &dt, const ivec &indeces );
-		void linkrvs ( RV &drv, RV &urv );
+		void set_rvs ( RV &drv, RV &urv );
 		void write ( vec &ut ) {it_error ( "MemDS::write is not supported" );}
-		void write ( vec &ut,ivec &indexes ) {it_error ( "MemDS::write is not supported" );}
+		void write ( vec &ut,ivec &indices ) {it_error ( "MemDS::write is not supported" );}
 		void step();
 		//!Default constructor
@@ -65,5 +65,5 @@
 		vec rgr;
 		//! data link: H -> rgr
-		datalink_e2e rgrlnk;
+		datalink *rgrlnk;
 		//! model of Y - linear Gaussian
 		mlnorm<chmat> model;
@@ -75,22 +75,22 @@
 	public:
 		void getdata ( vec &dt ) {
-			it_assert_debug ( dt.length() ==Drv.count(),"ArxDS" );
-			dt=H.left ( Urv.count() +Drv.count() );
+			//it_assert_debug ( dt.length() ==Drv.count(),"ArxDS" );
+			dt=H.left ( Urv._dsize() +Drv._dsize() );
 		};
-		void getdata ( vec &dt, const ivec &indexes ) {
-			it_assert_debug ( dt.length() ==indeces.length(),"ArxDS" );
-			dt=H ( indexes );
+		void getdata ( vec &dt, const ivec &indices ) {
+			it_assert_debug ( dt.length() ==indices.length(),"ArxDS" );
+			dt=H ( indices );
 		};
 		void write ( vec &ut ) {
-			it_assert_debug ( ut.length() ==Urv.count(),"ArxDS" );
+			//it_assert_debug ( ut.length() ==Urv.count(),"ArxDS" );
 			U=ut;
 		};
-		void write ( vec &ut, const ivec &indexes ) {
-			it_assert_debug ( ut.length() ==indeces.length(),"ArxDS" );
-			set_subvector ( U, indexes,ut );
+		void write ( vec &ut, const ivec &indices ) {
+			it_assert_debug ( ut.length() ==indices.length(),"ArxDS" );
+			set_subvector ( U, indices,ut );
 		};
 		void step();
 		//!Default constructor
-		ArxDS ( RV &drv, RV &urv, RV &rrv );
+		ArxDS ( ){};
 		//! Set parameters of the internal model
 		void set_parameters ( const mat &Th0, const vec mu0, const chmat &sqR0 )
@@ -119,5 +119,5 @@
 	class ARXDS : public ArxDS {
 	public:
-		ARXDS ( RV &drv, RV &urv, RV &rrv ) : ArxDS ( drv,urv,rrv ) {}
+		ARXDS ( ) : ArxDS ( ) {}
 
 		void getdata ( vec &dt ) {dt=H;}
@@ -145,9 +145,8 @@
 		void getdata ( vec &dt0, const ivec &indeces ) {dt0=dt ( indeces );}
 
-		stateDS ( mpdf* IM0, mpdf* OM0, RV &Urv0 ) :DS ( OM0->_rv(),Urv0 ),IM ( IM0 ),OM ( OM0 ),
-				dt ( OM0->_rv().count() ), xt ( IM0->_rv().count() ), ut ( Urv0.count() ) {}
+		stateDS ( mpdf* IM0, mpdf* OM0, int usize ) :DS ( ),IM ( IM0 ),OM ( OM0 ),
+				dt ( OM0->dimension() ), xt ( IM0->dimension() ), ut ( usize) {}
 		~stateDS() {delete IM; delete OM;}
 		virtual void step() {
-			double tmp;
 			xt=IM->samplecond(concat ( xt,ut ));
 			dt=OM->samplecond(concat ( xt,ut ));
Index: /bdm/stat/loggers.cpp
===================================================================
--- /bdm/stat/loggers.cpp (revision 262)
+++ /bdm/stat/loggers.cpp (revision 270)
@@ -27,5 +27,5 @@
 	int i,j,k;
 	int nsc=0;
-	for ( i=0;i<entries.length();i++ ) {nsc+=entries ( i ).count();}
+	for ( i=0;i<entries.length();i++ ) {nsc+=entries ( i )._dsize();}
 	; //all entries!!
 
Index: /bdm/stat/libBM.cpp
===================================================================
--- /bdm/stat/libBM.cpp (revision 265)
+++ /bdm/stat/libBM.cpp (revision 270)
@@ -5,55 +5,54 @@
 //! Space of basic BDM structures
 namespace bdm {
-
-using std::cout;
-
-static int RVcounter=0;
+	
+const int RV_BUFFER_STEP=1;
+RVmap RV_MAP;
+Array<string> RV_NAMES(RV_BUFFER_STEP);
+ivec RV_SIZES(RV_BUFFER_STEP);
 
 RV RV0=RV();
 
-void RV::init ( ivec in_ids, Array<std::string> in_names, ivec in_sizes, ivec in_times ) {
+int RV::init ( const string &name, int size ) {
 	//Refer
-	int i;
-	len = in_ids.length();
-	//PRUDENT_MODE
-	// All vetors should be of same length
-	if ( ( len != in_names.length() ) || \
-	        ( len != in_sizes.length() ) || \
-	        ( len != in_times.length() ) ) {
-		it_error ( "RV::RV inconsistent length of input vectors." );
-	}
-
-	ids = in_ids;
-	names = in_names;
-	sizes = in_sizes;
+	int id;
+	RVmap::const_iterator iter = RV_MAP.find ( name );
+	if ( iter == RV_MAP.end() ) {
+		id=RV_MAP.size()+1;
+		RV_MAP.insert ( make_pair ( name,id ) ); //add new rv
+		if (id>=RV_NAMES.length()){
+			RV_NAMES.set_length(id+RV_BUFFER_STEP,true);
+			RV_SIZES.set_length(id+RV_BUFFER_STEP,true);
+		}
+		RV_NAMES(id)=name;
+		RV_SIZES(id)=size;
+	}
+	else {
+		id = iter->second;
+		it_warning ("RV of name " + name + "already exists" );
+	}
+	return id;
+};
+
+int RV::countsize() const{ int tmp=0; for(int i=0;i<len;i++){tmp+=RV_SIZES(ids(i));} return tmp;}
+
+void RV::init ( Array<std::string> in_names, ivec in_sizes,ivec in_times ) {
+	len = in_names.length();
+	it_assert_debug ( in_names.length() ==in_times.length(), "check \"times\" " );
+	it_assert_debug ( in_names.length() ==in_sizes.length(), "check \"sizes\" " );
+	
+	times.set_length ( len );
+	ids.set_length ( len );
+	int id;
+	for ( int i=0; i<len; i++ ) {
+		id = init ( in_names ( i ), in_sizes ( i ) );
+		ids ( i ) = id;
+	}
 	times = in_times;
-	tsize = 0;
-	for ( i = 0;i < len;i++ ) {tsize += sizes ( i );}
-};
-
-RV::RV ( Array<std::string> in_names, ivec in_sizes, ivec in_times ) {
-	int len = in_names.length();
-	init ( linspace ( RVcounter+1, RVcounter+len ), in_names, in_sizes, in_times );
-	RVcounter+=len;
-}
-
-RV::RV ( Array<std::string> in_names, ivec in_sizes ) {
-	int len = in_names.length();
-	init ( linspace ( RVcounter+1, RVcounter+len ), in_names, in_sizes, zeros_i ( in_names.length() ) );
-	RVcounter+=len;
-}
-
-RV::RV ( Array<std::string> in_names ) {
-	int len = in_names.length();
-	init ( linspace ( RVcounter+1, RVcounter+len ), in_names, ones_i ( in_names.length() ), zeros_i ( in_names.length() ) );
-	RVcounter+=len;
-}
-
-RV::RV() : tsize ( 0 ), len ( 0 ), ids ( 0 ),  sizes ( 0 ), times ( 0 ),names ( 0 ) {};
-
-RV::RV(string name, int id, int sz, int tm){
-	if (id>RVcounter) {RVcounter=id;};
-	Array<string> A(1); A(0)=name;
-	init(vec_1(id),A,vec_1(sz),vec_1(tm));
+	dsize = countsize();
+}
+
+RV::RV ( string name, int sz, int tm ) {
+	Array<string> A ( 1 ); A ( 0 ) =name;
+	init (A,vec_1 ( sz ),vec_1 ( tm ) );
 }
 
@@ -64,43 +63,27 @@
 		ivec index = itpp::find ( ind==-1 );
 
-
 		if ( index.length() < rv2.len ) { //conflict
 			ids = concat ( ids, rv2.ids ( index ) );
-			sizes = concat ( sizes, rv2.sizes ( index ) );
 			times = concat ( times, rv2.times ( index ) );
-			names = concat ( names, rv2.names ( to_Arr ( index ) ) );
 		}
 		else {
 			ids = concat ( ids, rv2.ids );
-			sizes = concat ( sizes, rv2.sizes );
 			times = concat ( times, rv2.times );
-			names = concat ( names, rv2.names );
-		}
-		tsize = sum ( sizes );
+		}
 		len = ids.length();
-		return ( index.length() ==rv2.len );
+		dsize = countsize();
+		return ( index.length() ==rv2.len ); //conflict or not
 	}
 	else { //rv2 is empty
-		return true;
-	}
-//	return *this;
+		return true; // no conflict
+	}
 };
 
-// RV::RV ( ivec in_ids ) {
-//
-// 	len = in_ids.length();
-// 	Array<std::string> A ( len );
-// 	std::string rvstr = "rv";
-//
-// 	for ( int i = 0; i < len;i++ ) {
-// 		A ( i ) = rvstr + to_str ( i );
-// 	}
-//
-// 	init ( in_ids, A, ones_i ( len ), zeros_i ( len ) );
-// }
-
-RV RV::subselect (const ivec &ind ) const {
+RV RV::subselect ( const ivec &ind ) const {
 	RV ret;
-	ret.init ( ids ( ind ), names ( to_Arr ( ind ) ), sizes ( ind ), times ( ind ) );
+	ret.ids = ids(ind);
+	ret.times= times(ind);
+	ret.len = ind.length();
+	ret.dsize=ret.countsize();
 	return ret;
 }
@@ -108,18 +91,10 @@
 void RV::t ( int delta ) { times += delta;}
 
-RV RV::operator() (const ivec &ind ) const {
-	RV ret;
-	if ( ind.length() >0 ) {
-		ret.init ( ids ( ind ), names ( to_Arr ( ind ) ), sizes ( ind ), times ( ind ) );
-	}
-	return ret;
-}
-
 bool RV::equal ( const RV &rv2 ) const {
-	return ( ids == rv2.ids ) && ( times == rv2.times ) && ( sizes == rv2.sizes );
+	return ( ids == rv2.ids ) && ( times == rv2.times );
 }
 
 mat epdf::sample_m ( int N ) const {
-	mat X = zeros ( rv.count(), N );
+	mat X = zeros ( dim, N );
 	for ( int i = 0;i < N;i++ ) X.set_col ( i, this->sample() );
 	return X;
@@ -128,8 +103,9 @@
 
 std::ostream &operator<< ( std::ostream &os, const RV &rv ) {
-
+	int id;
 	for ( int i = 0; i < rv.len ;i++ ) {
-		os << rv.ids ( i ) << "(" << rv.sizes ( i ) << ")" <<  // id(size)=
-		"=" << rv.names ( i )  << "_{"  << rv.times ( i ) << "}; "; //name_{time}
+		id=rv.ids ( i );
+		os << id << "(" << RV_SIZES ( id ) << ")" <<  // id(size)=
+		"=" << RV_NAMES ( id )  << "_{"  << rv.times ( i ) << "}; "; //name_{time}
 	}
 	return os;
@@ -137,19 +113,19 @@
 
 str RV::tostr() const {
-	ivec idlist ( tsize );
-	ivec tmlist ( tsize );
+	ivec idlist ( dsize );
+	ivec tmlist ( dsize );
 	int i;
 	int pos = 0;
 	for ( i = 0;i < len;i++ ) {
-		idlist.set_subvector ( pos, pos + sizes ( i ) - 1, ids ( i ) );
-		tmlist.set_subvector ( pos, pos + sizes ( i ) - 1, times ( i ) );
-		pos += sizes ( i );
+		idlist.set_subvector ( pos, pos + size ( ids(i) ) - 1, ids ( i ) );
+		tmlist.set_subvector ( pos, pos + size ( ids(i) ) - 1, times ( i ) );
+		pos += size ( ids(i) );
 	}
 	return str ( idlist, tmlist );
 }
 
-ivec RV::dataind (const RV &rv2 ) const {
+ivec RV::dataind ( const RV &rv2 ) const {
 	ivec res ( 0 );
-	if ( rv2.count()>0 ) {
+	if ( rv2._dsize() >0 ) {
 		str str2 = rv2.tostr();
 		ivec part;
@@ -160,25 +136,25 @@
 		}
 	}
-	it_assert_debug(res.length()==tsize,"this rv is not fully present in crv!");
+	it_assert_debug ( res.length() ==dsize,"this rv is not fully present in crv!" );
 	return res;
 
 }
 
-void RV::dataind (const RV &rv2, ivec &selfi, ivec &rv2i) const {
+void RV::dataind ( const RV &rv2, ivec &selfi, ivec &rv2i ) const {
 	//clean results
-	selfi.set_size(0);
-	rv2i.set_size(0);
-	
+	selfi.set_size ( 0 );
+	rv2i.set_size ( 0 );
+
 	// just in case any rv is empty
-	if ((len==0)||(rv2.length()==0)){return;} 
-	
+	if ( ( len==0 ) || ( rv2.length() ==0 ) ) {return;}
+
 	//find comon rv
-	ivec cids=itpp::find(this->findself(rv2)>=0);
-	
-	// index of 
-	if ( cids.length()>0 ) {
+	ivec cids=itpp::find ( this->findself ( rv2 ) >=0 );
+
+	// index of
+	if ( cids.length() >0 ) {
 		str str1 = tostr();
-		str str2 = rv2.tostr();	
-		
+		str str2 = rv2.tostr();
+
 		ivec part1;
 		ivec part2;
@@ -186,5 +162,5 @@
 		// find common rv in strs
 		for ( j=0; j < cids.length();j++ ) {
-			i = cids(j);
+			i = cids ( j );
 			part1 = itpp::find ( ( str1.ids == ids ( i ) ) & ( str1.times == times ( i ) ) );
 			part2 = itpp::find ( ( str2.ids == ids ( i ) ) & ( str2.times == times ( i ) ) );
@@ -193,5 +169,5 @@
 		}
 	}
-	it_assert_debug(selfi.length() == rv2i.length(),"this should not happen!");
+	it_assert_debug ( selfi.length() == rv2i.length(),"this should not happen!" );
 }
 
@@ -199,5 +175,5 @@
 	ivec res = this->findself ( rv2 ); // nonzeros
 	ivec valid;
-	if (tsize>0) {valid= itpp::find ( res == -1 );} //-1 => value not found => it remains
+	if ( dsize>0 ) {valid= itpp::find ( res == -1 );} //-1 => value not found => it remains
 	return ( *this ) ( valid ); //keep those that were not found in rv2
 }
@@ -223,19 +199,17 @@
 }
 
-void RV::newids(){ids=linspace ( RVcounter+1, RVcounter+len ),RVcounter+=len;}
-
-RV compositepdf::getrv(bool checkoverlap){
+RV compositepdf::getrv ( bool checkoverlap ) {
 	RV rv; //empty rv
 	bool rvaddok;
-	for (int i = 0;i < n;i++ ) {
+	for ( int i = 0;i < n;i++ ) {
 		rvaddok=rv.add ( mpdfs ( i )->_rv() ); //add rv to common rvs.
-			// If rvaddok==false, mpdfs overlap => assert error.
-		it_assert_debug(rvaddok||(!checkoverlap),"mprod::mprod() input mpdfs overlap in rv!");
+		// If rvaddok==false, mpdfs overlap => assert error.
+		it_assert_debug ( rvaddok|| ( !checkoverlap ),"mprod::mprod() input mpdfs overlap in rv!" );
 	};
 	return rv;
 }
 
-void compositepdf::setrvc(const RV &rv, RV &rvc){
-	for (int i = 0;i < n;i++ ) {
+void compositepdf::setrvc ( const RV &rv, RV &rvc ) {
+	for ( int i = 0;i < n;i++ ) {
 		RV rvx = mpdfs ( i )->_rvc().subt ( rv );
 		rvc.add ( rvx ); //add rv to common rvc
@@ -243,6 +217,6 @@
 }
 
-void BM::bayesB(const mat &Data){
-	for(int t=0;t<Data.cols();t++){bayes(Data.get_col(t));}
-}
-}
+void BM::bayesB ( const mat &Data ) {
+	for ( int t=0;t<Data.cols();t++ ) {bayes ( Data.get_col ( t ) );}
+}
+}
